//+------------------------------------------------------------------+
//|                                                   RVI_anatol.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
extern double TakeProfit   = 55;
extern double Lots         =0.1;
extern double TrailingStop = 15; //20
extern double StopLoss     = 20; //25
extern int UrstoLow=40;
extern int UrstoHigh=60;
//extern int period=3;
extern int Mn=1964;
extern int D=10; //23
extern int Expiration=15; //30

extern int H_BUY=10;
extern int H_SELL=10;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
  double Stoh, CCI ;
  double DeM, RSI;
  double RVISignalPrevious,RVISignalCurrent,RVICurrent, RVIPrevious,SignalCurrent;  
  int cnt, ticket, total, Exp;

  double SPREAD=MarketInfo(Symbol(),MODE_SPREAD);
  double PRICE=0;
   Stoh=iStochastic(NULL,0,7,10,4,MODE_SMA,0,MODE_MAIN,0);
   SignalCurrent=iMACD(NULL,0,9,17,5,PRICE_CLOSE,MODE_SIGNAL,0);
   CCI=iCCI(NULL,0,9,PRICE_TYPICAL,0);
   DeM=iDeMarker(NULL,0,5,0);
   RSI=iRSI(NULL,0,5,PRICE_TYPICAL,0);
   
   if(OrdersTotal()!=0)
   {
      for(int i=OrdersTotal()-1;i>=0;i--)
      {
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderComment()=="anatol">=0 && OrderMagicNumber()==Mn)
         {
            if(OrderType()==OP_BUYSTOP)
            {
               if(OrderOpenPrice()-Ask>H_BUY*Point+1*Point && H_BUY*Point>MarketInfo(Symbol(),MODE_STOPLEVEL)*Point)
               {
                  PRICE=Ask+H_BUY*Point;
                  OrderModify(OrderTicket(),PRICE,PRICE-StopLoss*Point-SPREAD*Point,PRICE+TakeProfit*Point,Exp);
               }
            }
            if(OrderType()==OP_SELLSTOP)
            {
               if(Bid-OrderOpenPrice()>H_SELL*Point+1*Point && H_SELL*Point>MarketInfo(Symbol(),MODE_STOPLEVEL)*Point)
               {
                  PRICE=Bid-H_SELL*Point;
                  OrderModify(OrderTicket(),PRICE,PRICE+StopLoss*Point+SPREAD*Point,PRICE-TakeProfit*Point,Exp);
               }
            }
         }
      }
   
   }

    if(OrdersTotal()==0)
      {
      Exp=TimeLocal()+60*Period()*Expiration;
        // no opened orders identified
        if(AccountFreeMargin()<(0.001*Lots))
          {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
      return(0);  
     }
        if(Stoh<=40 && CCI<=-70 && RSI<=UrstoLow && DeM<=0.4)
           {
            ticket=OrderSend(Symbol(),OP_BUYSTOP,1,Ask+D*Point,0,
            Bid-StopLoss*Point,Ask+D*Point+TakeProfit*Point,"anatol",Mn,Exp,Green);
     if(ticket>0)
             {
               if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) 
                       Print("BUY order opened : ",OrderOpenPrice());
      }
           else 
        Print("Error opening BUY order : ",GetLastError()); 
        return(0); 
   }
     if(Stoh>=60 && CCI>=70 && RSI>=UrstoHigh && DeM>=0.60)
        {
           ticket=OrderSend(Symbol(),OP_SELLSTOP,1,Bid-D*Point,0,
          Bid+StopLoss*Point,Bid-D*Point-TakeProfit*Point,"anatol",Mn,Exp,Red);
    if(ticket>0)
            {
              if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) 
          Print("SELL order opened : ",OrderOpenPrice());
     }
         else 
      Print("Error opening SELL order : ",GetLastError()); 
      return(0); 
  }
    return(0);
 }
  for(cnt=OrdersTotal()-1;cnt>=0;cnt--)
     {
         OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
         if(OrderMagicNumber()==Mn)//   !!!!    !
         {
              if(OrderType()==OP_BUY)
              {
                  if(Stoh>=UrstoHigh && CCI>=100 && RSI>=UrstoHigh && DeM>=0.70)
                  {
                     OrderClose(OrderTicket(),OrderLots(),Bid,0,Violet); 
                     return(0);
                  }
                  if(TrailingStop>0)  
                  {                 
                     if(Bid-OrderOpenPrice()>Point*TrailingStop)
                     {
                        if(OrderStopLoss()<Bid-Point*StopLoss)                
                        {
                           OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*StopLoss,
                           OrderTakeProfit(),0,Green);                     
                           return(0);
                        }
                     }
                  }
              }
            if(OrderType()==1)
            {
               if(Stoh<=UrstoLow && CCI<=-100 && RSI<=UrstoLow && DeM<=0.3)
               {
                  OrderClose(OrderTicket(),OrderLots(),Ask,0,Violet); 
                  return(0);
               }
               if(TrailingStop>0)  
               {                 
                  if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                  {
                     if(OrderStopLoss()>(Ask+Point*StopLoss))  
                     {
                        OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*StopLoss,
                        OrderTakeProfit(),0,Red); 
                        return(0);
                     }
                  }
               }
            }
       }
     }
   return(0);
  }

